| Home | Libraries | People | FAQ | More

#### write (2 of 6 overloads)

Write a certain amount of data to a stream before returning.

    template<
        typename SyncWriteStream,
        typename ConstBufferSequence,
        typename CompletionCondition>
    std::size_t write(
        SyncWriteStream & s,
        const ConstBufferSequence & buffers,
        CompletionCondition completion_condition);

This function is used to write a certain number of bytes of data to a stream. The call will block until one of the following conditions is true:

- All of the data in the supplied buffers has been written. That is, the bytes transferred is equal to the sum of the buffer sizes.
- The completion_condition function object returns 0.

This operation is implemented in terms of zero or more calls to the stream's write_some function.

###### Parameters

s

  The stream to which the data is to be written. The type must support the SyncWriteStream concept.

buffers

  One or more buffers containing the data to be written. The sum of the buffer sizes indicates the maximum number of bytes to write to the stream.

completion_condition

  The function object to be called to determine whether the write operation is complete. The signature of the function object must be:

      std::size_t completion_condition(
        // Result of latest write_some operation.
        const boost::system::error_code& error,

        // Number of bytes transferred so far.
        std::size_t bytes_transferred
      );

  A return value of 0 indicates that the write operation is complete. A non-zero return value indicates the maximum number of bytes to be written on the next call to the stream's write_some function.

###### Return Value

The number of bytes transferred.

###### Exceptions

boost::system::system_error

  Thrown on failure.

###### Example

To write a single data buffer use the `buffer` function as follows:

    boost::asio::write(s, boost::asio::buffer(data, size),
        boost::asio::transfer_at_least(32));

See the `buffer` documentation for information on writing multiple buffers in one go, and how to use it with arrays, boost::array or std::vector.